/*
 * BFrame.java
 *
 * Created on 20 dicembre 2004, 22.15
 */

package Frames;

/** *
 * @author Stefano Secci
 *
 */

import java.awt.image.PixelGrabber;
import java.awt.image.ImageObserver;
import java.awt.Image;

public class BFrame extends PredictionFrame {
    
    /** Creates a new instance of PFrame */
    public BFrame(int SpanOrizzontaleAR, int SpanVerticaleAR, int SogliaBlockMatching, int SogliaBMMSE, int APics[][], int APicsFW[][], int APicsBW[][], boolean DecrementoAttivo) {
        SpanO=SpanOrizzontaleAR;
        SpanV=SpanVerticaleAR;       
        SogliaBM=SogliaBlockMatching;
        SogliaMSE=SogliaBMMSE;
        DecAtt=DecrementoAttivo;
        arrayPics=APics;
        arrayPicsFW=APicsFW;
        arrayPicsBW=APicsBW;
    }    
    
    public void loadLastFG(Image toLoad){
        LastRefFotogramma=toLoad;
    } 
    
    public void loadNextFG(Image toLoad){
        NextRefFotogramma=toLoad;
    } 
    
    public void loadFrameNextRic(Image toLoad){
        NextFrameRic=toLoad;
    } 
    
    public void loadFrameLastRic(Image toLoad){
        LastFrameRic=toLoad;
    } 
    
    public void detMotionVectors(){
        
        for (int col=0; col<8; ++col) {
            for (int row=0; row<6; ++row){           
                int i = row*6+col;                                
                detBlocco(EstraiBlocco(Fotogramma,col, row),EstraiBlocco(LastRefFotogramma,col, row),EstraiBlocco(NextRefFotogramma,col, row),col,row);
            }
        }
    }    
    
    private void detBlocco(int buf[],int bufLast[], int bufNext[], int col, int row){ 
  /*
   *determinazione del miglior macroblocco A a moto compensato in avanti:
  * considero il fotogramma del frame passato da cui effettuare la predizione e ne estraggo la componente di luminanza dell'area di ricerca
  * estraggo la componente di luminanza del blocco (col,row)
   *
  * calcolo Z_A=MAD fra il blocco (col,row) del frame passato e il corrispondente del frame
  * determino M0_A=MSE fra il blocco (col,row) del frame passato e il corrispondente del frame
   *
  *1: se Z_A  sotto la soglia scelgo per il blocco il vettore nullo e M_A=Matching Value=M0_A,  altrimenti
 * 2: determino il migliore vettore di moto nella finestra col proprio M_A=Matching Value.   
   *
   *determinazione del miglior macroblocco B a moto compensato in indietro:
   *eseguo le stesse operazioni per il fotogramma del frame futuro e ottengo Z2, M_B=Matching Value e M0_B.
   *
   *determinazione del macroblocco C interpolato:
   *M_C=(M_A+M_B)/2
   *vettore di moto=( (dx_A+dx_B)/2, (dy_A+dy_B)/2 )
   *
   *fra A,B,C scelgo il macroblocco con minor MSE: M_Finale = min(M_A, M_B, M_C)
   *se M_A=M_B=M_C -> scelgo C (indecisione)
   *
   *Scelgo se trasmettere il macroblocco trovato o quello Intra
   *se M_Finale<M0_A e M_Finale<M0_B -> Trasmetto Macroblocco trovato
   *se M_Finale=M0_A e M_Finale=M0_B -> Trasmetto Macroblocco trovato  (indecisione)
   *se M_Finale>M0_A o M_Finale>M0_B -> Trasmetto Macroblocco Intra 
  */          
        int YbloccoLast[]=detLuminanza(bufLast,256);
        int YbloccoNext[]=detLuminanza(bufNext,256);
        int InfoAR[]=getInfoAreaRicerca(col,row);
        int Yblocco[]=detLuminanza(buf,256);
        int AreaRicerca[]= getAreaRicerca(InfoAR,Fotogramma);           
        int YAreaRicerca[]=detLuminanza(AreaRicerca,InfoAR[0]*InfoAR[1]);
        
        // Macroblocco A
        int NIterazioniA=0;
        int M_A; int Z_A; int M0_A; int VetA[];        
        BlockMatching objBlkMatA=new BlockMatching(YbloccoLast,"B",SogliaMSE,DecAtt);            
        // se l'errore fra i blocchi non  oltre la soglia scelta il blocco si considera come non mosso        
        Z_A=objBlkMatA.MAD(Yblocco,YbloccoLast);
        M0_A=objBlkMatA.MSE(Yblocco,YbloccoLast);
        
        if ( Z_A <= SogliaBM){
            M_A=M0_A;
            VetA=new int[2];
            VetA[0]=VetA[1]=0;
        } else {
            // si procede alla ricerca del vettore di moto secondo l'algoritmo Full Search di Block Matching            
            int MatVal=objBlkMatA.getMatchingValue(YAreaRicerca,InfoAR[0],InfoAR[1],col,row,SpanO,SpanV);            
            M_A=MatVal;                
            VetA=objBlkMatA.getVector(); 
            NIterazioniA=objBlkMatA.NIterazioni;
        }                                
        arrayMatValA[col+row*8]=M_A;
        arrayM0A[col+row*8]=M0_A;
        arrayVetA[col+row*8]=VetA;
        arrayZA[col+row*8]=Z_A;
        
        
        // Macroblocco B        
        int NIterazioniB=0;
        int M_B; int Z_B; int M0_B; int VetB[];        
        BlockMatching objBlkMatB=new BlockMatching(YbloccoNext,"B",SogliaMSE,DecAtt);            
        // se l'errore fra i blocchi non  oltre la soglia scelta il blocco si considera come non mosso
        
        Z_B=objBlkMatB.MAD(Yblocco,YbloccoNext);
        M0_B=objBlkMatB.MSE(Yblocco,YbloccoNext);
        
        if ( Z_B <= SogliaBM){
            M_B=M0_B;
            VetB=new int[2];
            VetB[0]=VetB[1]=0;
        } else {
            // si procede alla ricerca del vettore di moto secondo l'algoritmo Full Search di Block Matching            
            int MatVal=objBlkMatB.getMatchingValue(YAreaRicerca,InfoAR[0],InfoAR[1],col,row,SpanO,SpanV);                        
            M_B=MatVal;                
            VetB=objBlkMatB.getVector(); 
            NIterazioniB=objBlkMatB.NIterazioni;
        }                
        arrayMatValB[col+row*8]=M_B;
        arrayM0B[col+row*8]=M0_B;
        arrayVetB[col+row*8]=VetB;
        arrayZB[col+row*8]=Z_B;
        
        // Macroblocco C
        int NIterazioniC=2; 
        int VetC[]=new int[2];
        VetC[0]=(VetA[0]+VetB[0])/2;
        VetC[1]=(VetA[1]+VetB[1])/2;        
        //int M_C=(objBlkMatA.detMatchingValue(YAreaRicercaA,InfoAR[0]+VetC[0],InfoAR[1]+VetC[1],InfoAR[0],InfoAR[1])+objBlkMatB.detMatchingValue(YAreaRicercaB,InfoAR[0]+VetC[0],InfoAR[1]+VetC[1],InfoAR[0],InfoAR[1]))/2;                
        int M_C=(M_A+M_B)/2;
        arrayMatValC[col+row*8]=M_C;        
        arrayVetC[col+row*8]=VetC;
        
        //Scelta macroblocco
        String tipoMBFinale="";
        int NIterazioniMBFinale=0;
        int Z_MBFinale=0;
        int M_MBFinale=0;
        int VetMBFinale[]=new int[2];
        if ((M_A<M_B)&(M_A<M_C)){
            tipoMBFinale="A";
            Z_MBFinale=Z_A;
            M_MBFinale=M_A;
            VetMBFinale[0]=VetA[0];
            VetMBFinale[1]=VetA[1];
            NIterazioniMBFinale=NIterazioniA;
        } else
        if ((M_B<M_A)&(M_B<M_C)){
            tipoMBFinale="B";
            Z_MBFinale=Z_B;
            M_MBFinale=M_B;
            VetMBFinale[0]=VetB[0];
            VetMBFinale[1]=VetB[1];
            NIterazioniMBFinale=NIterazioniB;
        } else {
            tipoMBFinale="C";
            Z_MBFinale=-1;
            M_MBFinale=M_C;
            VetMBFinale[0]=VetC[0];
            VetMBFinale[1]=VetC[1];
            NIterazioniMBFinale=NIterazioniC;
        }
        
        // Scelta tipo macroblocco da tramettere        
        //if ( ((M_MBFinale<M0_A)&(M_MBFinale<M0_B)) || ((M_MBFinale==M0_A)&(M_MBFinale==M0_B)) ){
        if ( !((M_MBFinale>M0_A)|(M_MBFinale>M0_B)) ){ 
            if ((VetMBFinale[0]==0)&(VetMBFinale[1]==0)){ // se si  trovato il vettore nullo
                if (tipoMBFinale.compareTo("A")==0) loadZeroBlockFW(col,row); 
                if (tipoMBFinale.compareTo("B")==0) loadZeroBlockBW(col,row); 
                if (tipoMBFinale.compareTo("C")==0) loadZeroBlock(col,row); 
            } else {
            loadVector(tipoMBFinale,VetMBFinale,col,row);            
            arrayNIterazioni[col+row*8]=NIterazioniMBFinale;
            }
        } else loadIntraBlock(col,row); 
        
        arrayZ[col+row*8]=Z_MBFinale;
        arrayMatVal[col+row*8]=M_MBFinale;        
    }
    
    public void loadZeroBlockBW(int col, int row){        
        insertBlockInFinalImage(arrayPicsBW[0],col,row,"Cod");   
        arrayTipoBlocchi[col+row*8]=3;
        NNul+=1;
    }
    
    public void loadZeroBlockFW(int col, int row){        
        insertBlockInFinalImage(arrayPicsFW[0],col,row,"Cod");   
        arrayTipoBlocchi[col+row*8]=2;
        NNul+=1;
    } 
    
    private void loadVector(String tipoMBFinale, int VettoreMoto[], int col, int row){
        arrayVet[col+row*8]=VettoreMoto;
        
        int indice=getIndicePic(VettoreMoto);        
    
        insertBlockInFinalImage(arrayPics[indice],col,row,"Cod");
        
        if (tipoMBFinale.compareTo("A")==0) {
            arrayTipoBlocchi[col+row*8]=5;
            insertBlockInFinalImage(arrayPicsFW[indice],col,row,"Cod");
        }
        if (tipoMBFinale.compareTo("B")==0) {
            arrayTipoBlocchi[col+row*8]=7;
            insertBlockInFinalImage(arrayPicsBW[indice],col,row,"Cod");
        }
        if (tipoMBFinale.compareTo("C")==0) {
            arrayTipoBlocchi[col+row*8]=6;
            insertBlockInFinalImage(arrayPics[indice],col,row,"Cod");
        } 
        NMc+=1;
    }
    
    public void Ricostruisci(){

        // prima i blocchi intra
        for (int col=0;col<8;col++){
            for (int row=0;row<6;row++){
                int NBlocco=col+row*8;
                if (arrayTipoBlocchi[NBlocco]==0){
                    insertBlockInFinalImage(EstraiBlocco(Fotogramma,col,row),col,row,"Ric");
                }
            }
        }         
        
        // poi i blocchi con vettore di moto non nullo
        for (int col=0;col<8;col++){
            for (int row=0;row<6;row++){
                int NBlocco=col+row*8;
                if (arrayTipoBlocchi[NBlocco]==5){
                    insertBlockMovedInFinalImage(EstraiBlocco(LastFrameRic,col,row),col,row,arrayVet[NBlocco]); 
                }
                if (arrayTipoBlocchi[NBlocco]==7){
                    insertBlockMovedInFinalImage(EstraiBlocco(NextFrameRic,col,row),col,row,arrayVet[NBlocco]); 
                }                
                if (arrayTipoBlocchi[NBlocco]==6){                    
                    insertBlockMovedInFinalImage(MeanRGBBlocco(EstraiBlocco(LastFrameRic,col,row),EstraiBlocco(NextFrameRic,col,row)),col,row,arrayVet[NBlocco]); 
                }                
            }
        }
        // poi i blocchi con vettore di moto nullo
        for (int col=0;col<8;col++){
            for (int row=0;row<6;row++){
                int NBlocco=col+row*8;
                if (arrayTipoBlocchi[NBlocco]==1){
                    insertBlockInFinalImage(EstraiBlocco(NextFrameRic,col,row),col,row,"Ric");
                }
                if (arrayTipoBlocchi[NBlocco]==2){
                    insertBlockInFinalImage(EstraiBlocco(LastFrameRic,col,row),col,row,"Ric");
                }
                if (arrayTipoBlocchi[NBlocco]==3){
                    insertBlockInFinalImage(EstraiBlocco(NextFrameRic,col,row),col,row,"Ric");
                }                
            }
        }
        
        // per i pixels rimasti blank
        for (int row=0;row<6;row++){
            for (int col=0;col<8;col++){
            
                
                //if (arrayTipoBlocchi[col+row*8]==5){
                    for (int j=0;j<16;j++){
                        for (int i=0;i<16;i++){
                            int indicepx=(row*16+j)*128+col*16+i;
                            int xpixel=16*col+i;
                            int ypixel=16*row+j;
                            if (bufFinalImageRic[indicepx]==0) bufFinalImageRic[indicepx]=getPixelAt(Fotogramma,xpixel,ypixel);
                        }
                    } /*           
                }
                if (arrayTipoBlocchi[col+row*8]==7){
                    for (int j=0;j<16;j++){
                        for (int i=0;i<16;i++){
                            int indicepx=(row*16+j)*128+col*16+i;
                            int xpixel=16*col+i;
                            int ypixel=16*row+j;
                            if (bufFinalImageRic[indicepx]==0) bufFinalImageRic[indicepx]=getPixelAt(NextFrameRic,xpixel,ypixel);
                        }
                    }            
                }
                if (arrayTipoBlocchi[col+row*8]==6){
                    for (int j=0;j<16;j++){
                        for (int i=0;i<16;i++){
                            int indicepx=(row*16+j)*128+col*16+i;
                            int xpixel=16*col+i;
                            int ypixel=16*row+j;
                            if (bufFinalImageRic[indicepx]==0) bufFinalImageRic[indicepx]=MeanRGB(getPixelAt(NextFrameRic,xpixel,ypixel),getPixelAt(LastFrameRic,xpixel,ypixel));
                        }
                    }            
                }*/                
            }
        }        
       
                
    }
    
    private int arrayPicsFW[][];
    private int arrayPicsBW[][];    
    private Image LastRefFotogramma;
    private Image NextRefFotogramma;    
    private Image NextFrameRic; 
    private Image LastFrameRic; 
    public int arrayM0A[]=new int[8*6];
    public int arrayMatValA[]=new int[8*6];
    public int arrayZA[]=new int[8*6];
    public int arrayVetA[][]=new int[8*6][2];    
    public int arrayM0B[]=new int[8*6];
    public int arrayMatValB[]=new int[8*6];
    public int arrayZB[]=new int[8*6];
    public int arrayVetB[][]=new int[8*6][2];    
    public int arrayMatValC[]=new int[8*6];
    public int arrayVetC[][]=new int[8*6][2];
    private int SogliaMSE;
}

