/*
 * BlockMatching.java
 *
 * Created on 5 gennaio 2005, 17.14
 */
package Frames;
/**
 *
 * @author Stefano Secci
 */

import java.awt.image.PixelGrabber;
import java.awt.image.ImageObserver;
import java.awt.image.*;
import java.awt.*;
import java.awt.Image;

public class BlockMatching extends javax.swing.JApplet {
    
    /** Creates a new instance of BlockMatching */
    public BlockMatching(int[] Blk, String typeFrame, int SogliaMatVal, boolean DecrementoAttivo) {
        BlkBase=Blk;
        typeF=typeFrame;
        SogliaVal=SogliaMatVal;
        DecAtt=DecrementoAttivo;        
    }
           
    public int getMatchingValue(int SearchArea[], int widthSA, int heightSA, int col, int row, int SpanO, int SpanV){        
        
        int BlkTemp[]= new int[16*16];
        int MValue=-1;                              
        int xCentroSA=0; 
        int yCentroSA=0;
        
        int distanzaBordoSinistro=col*16-SpanO;
        int distanzaBordoDestro=128-((col+1)*16+SpanO);
        int distanzaBordoAlto=row*16-SpanV;
        int distanzaBordoBasso=96-((row+1)*16+SpanV);
        
        // se si tratta di un blocco non esattamente centrato nella sua area di ricerca si procede con un algoritmo di tipo
        // Full Search esaustivo che scansisce l'area di ricerca in ordine letterario
        if (!((distanzaBordoBasso>0)&(distanzaBordoAlto>0)&(distanzaBordoSinistro>0)&(distanzaBordoDestro>0))){
        
        if (col!=0) xCentroSA=SpanO;
        if (row!=0) yCentroSA=SpanV;
        for (int x=0;x<widthSA-16;x++){
            for (int y=0;y<heightSA-16;y++){
                MValue=detMatchingValue(SearchArea,x,y,widthSA, heightSA);
                // aggiorna il minimo
                if (MValue<VMin){
                    VMin=MValue;
                    coordMadMin[0]=x-xCentroSA; coordMadMin[1]=yCentroSA-y;
                }
                // Se il valore minimo raggiunto del Matching Value  sotto la soglia (MAD per P-Frame, MSE per B-Frame) termina
                if (VMin<SogliaVal){
                    x=widthSA; y=heightSA;
                    break;
                }
            }
        }
        
        // altrimenti si procede con un algoritmo di Full Search di tipo TM5 che procede a spirale partendo dal centro
        // dell'area di ricerca, ovvero dal vertice superiore sinistro del blocco in considerazione, fino alla peroferia
        // con una spirale che si sviluppa in senso orario in modo esaustivo
        } else {
        
            xCentroSA=SpanO+8-1;
            yCentroSA=SpanV+7-1;
            
        int x=xCentroSA;
        int y=yCentroSA; 
            
            for (int k=1;k<widthSA+1;k+=2){ 
            // k indica la dimensione del passo nella prima discesa e nella prima "svolta a destra" della spirale (ad ogni giro)
            // k+1 indica la dimensione del passo nella prima salita e nella seconda "svolta a destra" della spirale (ad ogni giro)
                
                int dec=0;
                // se  selezionata la variante all'algoritmo di Full search
                if (DecAtt){
                    if (typeF.compareTo("P")==0) dec= k;
                    if (typeF.compareTo("B")==0) dec= k*10;                    
                    if (k==1) dec=1;
                }                
                                
                // ramo discendente della spirale di ricerca
                for (int r=1;r<=k;r++){
                    if  (  !(((y+1)+(16-7)+SpanV)>heightSA) )   {               
                        y+=1;
                        MValue=detMatchingValue(SearchArea,x-8,y-7,widthSA, heightSA); //(x-8,y-7) vertice del blocco
                        
                    } else {                  // se il blocco esce fuori dall'area di ricerca, interrompi la ricerca
                        k=widthSA+1;
                        break;
                    }
                    // aggiorna il valore minimo
                    if (MValue<(VMin-dec)){      // valore minimo decrementato di dec per dare meno peso ai blocchi lontani che potrebbero 
                        VMin=MValue;          // generare alias nel riconoscimento a causa di eventuali dettagli che provocano una forte variazione di luminanza
                        coordMadMin[0]=x-xCentroSA; coordMadMin[1]=yCentroSA-y;
                    }
                    // Se il valore minimo raggiunto del Matching Value  sotto la soglia (MAD per P-Frame, MSE per B-Frame) termina
                    if (VMin<SogliaVal){
                        k=widthSA+1;
                        break;
                    }
                }                
                if (k==widthSA+1) break;      // si  arrivati alla fine della spirale
                
                // ramo verso sinistra della spirale 
                for (int r=1;r<=k;r++){
                    if  (  !(((x+1)+(16-8)+SpanV)>widthSA) )   {               
                        x-=1;
                        MValue=detMatchingValue(SearchArea,x-8,y-7,widthSA, heightSA);                    
                    } else { 
                        k=widthSA+1;
                        break;
                    }                    
                    if (MValue<(VMin-dec)){
                        VMin=MValue;
                        coordMadMin[0]=x-xCentroSA; coordMadMin[1]=yCentroSA-y;
                    }
                    if (VMin<SogliaVal){
                        k=widthSA+1;
                        break;
                    }
                }                
                if (k==widthSA+1) break;
                
                // ramo verso l'alto della spirale
                for (int r=1;r<=k+1;r++){
                    if  (  !((y+10+SpanV)>heightSA) )   {               
                        y-=1;
                        MValue=detMatchingValue(SearchArea,x-8,y-7,widthSA, heightSA);                    
                    } else {  
                        k=widthSA+1;
                        break;
                    }                    
                    if (MValue<(VMin-dec)){
                        VMin=MValue;
                        coordMadMin[0]=x-xCentroSA; coordMadMin[1]=yCentroSA-y;
                    }
                    if (VMin<SogliaVal){
                        k=widthSA+1;
                        break;
                    }
                }                
                if (k==widthSA+1) break;                
                
                // ramo verso destra della spirale
                for (int r=1;r<=k+1;r++){
                    if  (  !((x+9+SpanV)>widthSA) )   {               
                        x+=1;
                        MValue=detMatchingValue(SearchArea,x-8,y-7,widthSA, heightSA);                    
                    } else {  
                        k=widthSA+1;
                        break;
                    }
                    if (MValue<(VMin-dec)){
                        VMin=MValue;
                        coordMadMin[0]=x-xCentroSA; coordMadMin[1]=yCentroSA-y;
                    }
                    if (VMin<SogliaVal){
                        k=widthSA+1;
                        break;
                    }
                } 
            }
        }
        
        return MValue;                
    }
    
    public int detMatchingValue(int SearchArea[], int x, int y, int widthSA, int heightSA) {  
        NIterazioni+=1;
        if (typeF.compareTo("P")==0) return MAD(BlkBase,EstraiBlocco(SearchArea,x,y,widthSA, heightSA));    
        if (typeF.compareTo("B")==0) return MSE(BlkBase,EstraiBlocco(SearchArea,x,y,widthSA, heightSA));  
        return -1;
    }            
    
    private int[] EstraiBlocco(int SearchArea[], int x, int y, int widthSA, int heightSA){        
        
        /* algoritmo seriale di estrazione del blocco
         int BlkTemp[]= new int[16*16];
        int initPoint=x+y*widthSA;
        
        for (int j=0;j<16;j++){
            for (int i=0;i<16;i++){
                BlkTemp[i+j*16]=SearchArea[initPoint+i+j*widthSA];
            }
        }        
        return BlkTemp;*/
        Image SA=createImage(new MemoryImageSource(widthSA, heightSA, SearchArea, 0, widthSA));
        int buf[] = new int[256];
        PixelGrabber pg = new PixelGrabber(SA, x, y, 16, 16, buf, 0, 16);
        
        try {
            pg.grabPixels();
        } catch (InterruptedException e) {
            throw new Error("Cannot grab image.");
        }
        if ((pg.getStatus() & ImageObserver.ABORT) != 0) {
            throw new Error("Cannot grab image.");
        }        
        return buf;         
    }    
    
    public int[] getVector(){
        return coordMadMin;
    }
    
    public int MAD(int[] Blk1, int[] Blk2){
        int Mad=0;
        for (int i=0;i<256;i++) Mad+=Math.abs(Blk1[i]-Blk2[i]);             
        Mad=Mad/256;
        return Mad;
    }        
    
    public int MSE(int[] Blk1, int[] Blk2){
        int Mse=0;
        for (int i=0;i<256;i++) Mse+=(Blk1[i]-Blk2[i])*(Blk1[i]-Blk2[i]);
        Mse=Mse/256;
        return Mse;
    }
    
    //public int NIt;
    private int[] BlkBase;
    private int VMin=1000000000;
    private int coordMadMin[]=new int[2];
    private int SogliaVal;
    private String typeF;
    private boolean DecAtt=false;
    public int NIterazioni=0;
}
