/*
 * PFrame.java
 *
 * Created on 20 dicembre 2004, 22.15
 */

package Frames;

/** *
 * @author Stefano Secci
 *
 */

import java.awt.image.PixelGrabber;
import java.awt.image.ImageObserver;
import java.awt.Image;

public class PFrame extends PredictionFrame {
    
    /** Creates a new instance of PFrame */
    public PFrame(int SpanOrizzontaleAR, int SpanVerticaleAR, int SogliaBlockMatching, int SogliaBMMAD, int APics[][], boolean DecrementoAttivo) {
        SpanO=SpanOrizzontaleAR;
        SpanV=SpanVerticaleAR;       
        SogliaBM=SogliaBlockMatching;
        arrayPics=APics;
        SogliaMAD=SogliaBMMAD;
        DecAtt=DecrementoAttivo;
    }    
        
    public void loadRefFotogramma(Image IFrame){
        RefFotogramma=IFrame;
    } 
    
    public void loadFrameImage(Image FrameImage){
        Fotogramma=FrameImage;
    }
    public void detMotionVectors(){
        
        for (int col=0; col<8; ++col) {
            for (int row=0; row<6; ++row){           
                int i = row*6+col;                                
                detBlocco(EstraiBlocco(RefFotogramma,col, row),col,row);
            }
        }
    }
    
    private void detBlocco(int buf[], int col, int row){       
 /* considero il fotogramma del frame passato su cui effettuare la predizione e ne estraggo la componente di luminanza dell'area di ricerca
  * estraggo la componente di luminanza del blocco (col,row) del P-Frame
  * calcolo Z=MAD fra il blocco (col,row) e il corrispondente (a vettore nullo) del frame su cui si predige
  *
  *1: se Z  sotto la soglia trasmetto il vettore nullo, altrimenti
 * 2: determino il migliore vettore di moto nella finestra col proprio Matching Value.
 * 3: se il vettore trovato  nullo lo trasmetto, altrimenti
 * 4: in base alla caratteristica Mc_NoMc(Z,MatVal) scelgo se codificare il vettori di moto o il blocco come Intra
  */
        int blocco[]=buf;
        int Yblocco[]=detLuminanza(buf,256);
        int InfoAR[]=getInfoAreaRicerca(col,row);
        int AreaRicerca[]= getAreaRicerca(InfoAR,Fotogramma);        
        int YAreaRicerca[]=detLuminanza(AreaRicerca,InfoAR[0]*InfoAR[1]);
        BlockMatching objBlkMat=new BlockMatching(Yblocco,"P", SogliaMAD,DecAtt);
        // se l'errore fra i blocchi non  oltre la soglia scelta il blocco si considera come non mosso
        int Z=objBlkMat.MAD(Yblocco,detLuminanza(EstraiBlocco(Fotogramma,col,row),256)); 
        arrayZ[col+row*8]=Z;
        if ( Z <= SogliaBM){
            loadZeroBlock(col,row);
            arrayMatVal[col+row*8]=Z;
        } else {
            // si procede alla ricerca del vettore di moto secondo l'agoritmo Full Search di Block Matching                      
            int MatVal=objBlkMat.getMatchingValue(YAreaRicerca,InfoAR[0],InfoAR[1],col,row,SpanO,SpanV);           
            arrayMatVal[col+row*8]=MatVal;
            
            // verifica se il vettore trovato  nullo, se si lo trasmetto 
            if ((objBlkMat.getVector()[0]==0)&(objBlkMat.getVector()[1]==0)) { 
                    loadZeroBlock(col,row); 
                } else {
                // decido in base alla caratteristica di Mc/NoMc se codificare i vettori o i frame come intra            
                if (CarMc.isMC(Z, MatVal)) {
                    loadVector(objBlkMat.getVector(), col, row);
                    arrayNIterazioni[col+row*8]=objBlkMat.NIterazioni;
                } else loadIntraBlock(col,row);
                }
        }               
    }  
    
   
    private void loadVector(int VettoreMoto[], int col, int row){
        arrayVet[col+row*8]=VettoreMoto;
        
        int indice=getIndicePic(VettoreMoto);
        
        insertBlockInFinalImage(arrayPics[indice],col,row,"Cod");
        arrayTipoBlocchi[col+row*8]=3;
    }
    
    public void loadFrameRic(Image toLoad){
        FrameRic=toLoad;
    }
    
    public void Ricostruisci(){

        // prima i blocchi intra
        for (int col=0;col<8;col++){
            for (int row=0;row<6;row++){
                int NBlocco=col+row*8;
                if (arrayTipoBlocchi[NBlocco]==0){
                    insertBlockInFinalImage(EstraiBlocco(Fotogramma,col,row),col,row,"Ric");
                }
            }
        }         
        
        // poi i blocchi con vettore di moto non nullo
        for (int col=0;col<8;col++){
            for (int row=0;row<6;row++){
                int NBlocco=col+row*8;
                if (arrayTipoBlocchi[NBlocco]==3){
                    insertBlockMovedInFinalImage(EstraiBlocco(FrameRic,col,row),col,row,arrayVet[NBlocco]); 
                }
            }
        }
        // poi i blocchi con vettore di moto nullo
        for (int col=0;col<8;col++){
            for (int row=0;row<6;row++){
                int NBlocco=col+row*8;
                if (arrayTipoBlocchi[NBlocco]==1){
                    insertBlockInFinalImage(EstraiBlocco(FrameRic,col,row),col,row,"Ric");
                }
            }
        }
        
        // per i pixels rimasti blank
        for (int row=0;row<6;row++){
            for (int col=0;col<8;col++){
                if (arrayTipoBlocchi[col+row*8]==3){
                    for (int j=0;j<16;j++){
                        for (int i=0;i<16;i++){
                            int indicepx=(row*16+j)*128+col*16+i;
                            int xpixel=16*col+i;
                            int ypixel=16*row+j;
                            if (bufFinalImageRic[indicepx]==0) bufFinalImageRic[indicepx]=getPixelAt(Fotogramma,xpixel,ypixel);
                        }
                    }            
                }
            }
        }        
       
                
    }
    
    

    private Image RefFotogramma;
    private Image FrameRic;
    private Caratteristica_Mc_NoMc CarMc=new Caratteristica_Mc_NoMc();    
    private int SogliaMAD;
}
