/*
 * PredictionFrame.java
 *
 * Created on 14 gennaio 2005, 14.34
 */

package Frames;

/**
 *
 * @author Stefano Secci
 */

import java.awt.image.PixelGrabber;
import java.awt.image.ImageObserver;
import java.awt.Image;


public class PredictionFrame extends java.applet.Applet {
    
    /** Creates a new instance of PredictionFrame */
    public PredictionFrame() {
    }
    
    public void loadFrameImage(Image FrameImage){
        Fotogramma=FrameImage;
    }
    
    public int[] detLuminanza(int [] buf, int DimBuf){
        int bufR[]=new int[DimBuf];
        int bufG[]=new int[DimBuf];
        int bufB[]=new int[DimBuf];
        int bufY[]=new int[DimBuf];
        
        for (int i=0;i<DimBuf;i++) {
            int pixel=buf[i];
            //int alpha = (pixel >> 24) & 0xff;//
            int red   = (pixel >> 16) & 0xff;//
            int green = (pixel >>  8) & 0xff;//
            int blue  = (pixel      ) & 0xff;//
            bufR[i]=red;
            bufG[i]=green;
            bufB[i]=blue;
            bufY[i]=(int)(0.299*bufR[i]+0.587*bufG[i]+0.114*bufB[i]);
        } 
        return bufY;
    }    
    
    public void loadIntraBlock(int col, int row){
        arrayTipoBlocchi[col+row*8]=0;
        insertBlockInFinalImage(EstraiBlocco(Fotogramma,col,row),col,row,"Cod");  
        NIntra+=1;
    }
    
    public int[] getInfoAreaRicerca(int col, int row){
        int width=0;   int height=0;
        int x=0;       int y=0;
        int result[]= new int[4];
        
        // se blocco di contorno destro o sinistro
        // per col=0 sempre x=0 | per y=0 sempre y=0
        
        if ((col==0)|(col==7)) {
            width=SpanO+16;
            if (col==7) x=16*col-(SpanO+1);
        } else {
            width=16+2*SpanO;
            x=16*col-(SpanO+1);
        }        
        // se blocco di contorno alto o basso
        if ((row==0)|(row==5)) {
            height=SpanV+16;
            if (row==5) y=16*row-(SpanV+1);
        } else {
            height=16+2*SpanV;
            y=16*row-(SpanV+1);
        }
        result[0]=width;   result[1]=height;
        result[2]=x;       result[3]=y;
        return result;            
    }    
    
    public void loadZeroBlock(int col, int row){        
        insertBlockInFinalImage(arrayPics[0],col,row,"Cod");   
        arrayTipoBlocchi[col+row*8]=1;
        NNul+=1;
    }    
    
    public int[] getAreaRicerca(int InfoAR[],Image RefFotogramma){
        int buf[] = new int[InfoAR[0]*InfoAR[1]];
        
        PixelGrabber pg = new PixelGrabber(RefFotogramma, InfoAR[2], InfoAR[3], InfoAR[0], InfoAR[1], buf, 0, InfoAR[0]);
        
        try {
            pg.grabPixels();
        } catch (InterruptedException e) {
            throw new Error("Cannot grab image.");
        }
        if ((pg.getStatus() & ImageObserver.ABORT) != 0) {
            throw new Error("Cannot grab image.");
        }
        return buf;
    }    
    
    public int[] EstraiBlocco(Image FG, int col, int row){
        int buf[] = new int[256];
        PixelGrabber pg = new PixelGrabber(FG, col*16, row*16, 16, 16, buf, 0, 16);
        
        try {
            pg.grabPixels();
        } catch (InterruptedException e) {
            throw new Error("Cannot grab image.");
        }
        if ((pg.getStatus() & ImageObserver.ABORT) != 0) {
            throw new Error("Cannot grab image.");
        }
        return buf;               
    }    
    
    public void insertBlockInFinalImage(int bufBlock[], int col, int row, String type){
        
        int initPoint=128*16*row+16*col;
        for (int j=0;j<16;j++){
            for (int i=0;i<16;i++){
                int Ipixel=initPoint+i+j*128;
                if (type.compareTo("Cod")==0) bufFinalImage[Ipixel]=bufBlock[i+j*16];
                if (type.compareTo("Ric")==0) {
                    if (bufFinalImageRic[Ipixel]==0) {bufFinalImageRic[Ipixel]=bufBlock[i+j*16];}
                else bufFinalImageRic[Ipixel]=MeanRGB(bufFinalImageRic[Ipixel],bufBlock[i+j*16]);
                }                    
            }
        }        
    } 
    
    public void insertBlockMovedInFinalImage(int bufBlock[], int col, int row, int Vet[]){
        int xpixel=16*col+Vet[0];
        int ypixel=16*row-Vet[1];
        // se il blocco si sposta fuori dall'immagine esci.
        if ((xpixel>128)|(ypixel>96)||(xpixel+16<=0)||(ypixel+16<=0)) return;
        // se il blocco esce parzialmente dall'immagine
        if ((xpixel<0)|(xpixel+16>128)|(ypixel<0)|(ypixel+16>96)){
            int widthArea=16;
            int heightArea=16;            
            int xspan=0; 
            int yspan=0;
            int xinitPoint=xpixel;
            int yinitPoint=ypixel;
            
            if (xpixel<0) {
                widthArea=xpixel+16;
                xspan=16-widthArea;
                xinitPoint=0;
            }                
            if (xpixel+16>128) widthArea=16-(xpixel-128); //xspan=0
            if (ypixel<0) {
                heightArea=ypixel+16;
                yspan=(16-heightArea)*16;
                yinitPoint=0;
            }                
            if (ypixel+16>96) heightArea=16-(ypixel-96); //yspan=0;
            
            int blkInitPoint=yspan+xspan;        
            
            int initPoint=yinitPoint*128+xinitPoint;
            
            for (int j=0;j<heightArea;j++){
                for (int i=0;i<widthArea;i++){ 
                    int indice=initPoint+i+j*128;
                    if (bufFinalImageRic[indice]==0) {bufFinalImageRic[indice]=bufBlock[blkInitPoint+i+j*16];}
                else bufFinalImageRic[indice]=MeanRGB(bufFinalImageRic[indice],bufBlock[blkInitPoint+i+j*16]);
                }
            }
            return;
        }        
        
        // altrimenti il blocco si sposta in una posizione interna totalmente al fotogramma
        int initPoint=128*(ypixel)+xpixel;
        
        for (int j=0;j<16;j++){
            for (int i=0;i<16;i++){
                int indice=initPoint+i+j*128;
                if (bufFinalImageRic[indice]==0) { bufFinalImageRic[indice]=bufBlock[i+j*16];}
                else bufFinalImageRic[indice]=MeanRGB(bufFinalImageRic[indice],bufBlock[i+j*16]);
            }
        } 
    }
    
    public int[] MeanRGBBlocco(int blk1[], int blk2[]){
        int newBlocco[]=new int[256];
        for (int i=0;i<256;i++) newBlocco[i]=MeanRGB(blk1[i],blk2[i]);
        return newBlocco;
    }
    
    public int MeanRGB(int pix1, int pix2){
        
        int alpha1 = (pix1 >> 24) & 0xff;//
        int red1   = (pix1 >> 16) & 0xff;//
        int green1 = (pix1 >>  8) & 0xff;//
        int blue1  = (pix1      ) & 0xff;//        
        
        int alpha2 = (pix2 >> 24) & 0xff;//
        int red2   = (pix2 >> 16) & 0xff;//
        int green2 = (pix2 >>  8) & 0xff;//
        int blue2  = (pix2      ) & 0xff;//        
        
        int newred=(red1+red2)/2; int newgreen=(green1+green2)/2; int newblue=(blue1+blue2)/2; int newalpha=(alpha1+alpha2)/2;
        int newpixel = (newalpha << 24) | (newred << 16) | (newgreen << 8) | newblue;
        return newpixel;
    }
    
        
    
    public int getPixelAt(Image img, int i, int j){
        int buf[]=new int[1];
        PixelGrabber pg= new PixelGrabber(img, i, j, 1, 1, buf, 0, 1);
        try {
            pg.grabPixels();
        } catch (InterruptedException e) {
            throw new Error("Cannot grab image.");
        }
        if ((pg.getStatus() & ImageObserver.ABORT) != 0) {
            throw new Error("Cannot grab image.");
        }
        return buf[0];          
    }
    
    public int getIndicePic(int VettoreMoto[]){
        
        int ang=0; int size=0; int signum_x=0; int signum_y=0;
        double AngoloVettore;
        
        if (VettoreMoto[0]==0) {
          AngoloVettore=90;  
        } else AngoloVettore=Math.abs(180*Math.atan(VettoreMoto[1]/VettoreMoto[0])/3.1415926);
        
        double AbsVettore=Math.sqrt(VettoreMoto[0]*VettoreMoto[0]+VettoreMoto[1]*VettoreMoto[1]);
        double MaxAbsVet=Math.sqrt(SpanO*SpanO+SpanV*SpanV);
        
        if (AbsVettore/MaxAbsVet>=0.8)                             size=0; //Big
        if ((AbsVettore/MaxAbsVet>0.2)&(AbsVettore/MaxAbsVet<0.8)) size=1; //Medium
        if (AbsVettore/MaxAbsVet<=0.2)                             size=2; //Small
        
        if (VettoreMoto[0]>=0)  signum_x=0;  //Positive
        if (VettoreMoto[1]>=0)  signum_y=0;  //Positive
        if (VettoreMoto[0]<0) signum_x=1;   //Negative
        if (VettoreMoto[1]<0) signum_y=1;   //Negative
        
        if (AngoloVettore<3)                         ang=0;
        if ((AngoloVettore>=3)&(AngoloVettore<35))   ang=1;
        if ((AngoloVettore>=35)&(AngoloVettore<=55)) ang=2;       
        if ((AngoloVettore>55)&(AngoloVettore<=85))  ang=3; 
        if ((AngoloVettore>87)&(AngoloVettore<=90))  ang=4;         

        int i=1; int indice=0;
        for (int sz=0;sz<3;sz++){
            for (int ag=0;ag<5;ag++){
                for (int sgx=0;sgx<2;sgx++){
                    for (int sgy=0;sgy<2;sgy++){
                        if ((ang==ag)&(sz==size)&(sgx==signum_x)&(sgy==signum_y)) {
                            indice=i;
                            sgx=2;sgy=2;ag=5;sz=3;
                        }                            
                        i+=1;
                    }                    
                }            
            }
        }        
        return indice;
        
    }
    
    public int SpanO;
    public int SpanV;
    public int SogliaBM;
    public int arrayPics[][];
    public int arrayMatVal[]=new int[8*6];
    public int arrayZ[]=new int[8*6];
    public int arrayVet[][]=new int[8*6][2];
    
    public Image Fotogramma;
    public int bufFinalImage[]= new int[128*96];        
    public int bufFinalImageRic[]= new int[128*96];
    public int arrayTipoBlocchi[]=new int[8*6];
    
    public int arrayNIterazioni[]=new int[8*6];
    public int NIntra=0;
    public int NMc=0;
    public int NNul=0;
    public boolean DecAtt=false;    
}
    
